package ksoapTests;
 
import java.io.*;
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
 
import org.ksoap.*;
import org.kobjects.serialization.*;
import org.kxml.*;
import org.kxml.io.*;
import org.kxml.parser.*;

public class StockOrderRequest extends MIDlet implements CommandListener {

  private Display display;
  private Command doneCommand;
  private TextField textField;

  public StockOrderRequest () throws Exception {
    // Initialize display and command objects.
    display = Display.getDisplay(this);
    doneCommand = new Command("DONE", Command.CANCEL, 1);
  }

  private String assembleRequest (SoapObject method) throws Exception {
    // Assemble "method" into an envelopped SOAP message
    // and then export to a String.
    ByteArrayOutputStream bos = new ByteArrayOutputStream ();
    XmlWriter xw = new XmlWriter (new OutputStreamWriter (bos));
    // Use default mapping between Java objects and Soap elements;
    SoapEnvelope envelope = new SoapEnvelope (new ClassMap (Soap.VER12));
    envelope.setBody (method);
    envelope.write (xw);
    xw.flush ();
    bos.write ('\r');
    bos.write ('\n');
    byte [] requestData = bos.toByteArray ();
    return new String (requestData);
  }

  public void startApp() {

    // SoapObject "method" is the calling construct.
    SoapObject method = new SoapObject("",
                                       "StockOrderParameters");
    method.addProperty("Symbol", "XYZ");
    method.addProperty("From", "Michael Yuan");
    method.addProperty("Shares", new Integer (1000));
    method.addProperty("Buy", new Boolean (true));
    method.addProperty("LimitPrice", 
                       new SoapPrimitive ("http://www.w3.org/2001/XMLSchema", 
                                          "float", 
                                          "123.45"));

    String mesg = "to be replaced";
    try {
      mesg = assembleRequest (method);
    } catch (Exception e) { 
      mesg = "Error in processing \n";
      e.printStackTrace ();
    }
    System.out.print (mesg);

    TextBox textBox = new TextBox ("Request Soap Message", null,
                                   1024, TextField.ANY);
    textBox.setString(mesg);
    textBox.addCommand(doneCommand);
    textBox.setCommandListener( (CommandListener) this);
    display.setCurrent(textBox);
  }

  public void pauseApp() {
  }
 
  public void destroyApp(boolean unconditional) {
  }

  public void commandAction(Command command, Displayable screen) {
    if (command == doneCommand) {
      destroyApp(false);
      notifyDestroyed();
    } else {
      // Do nothing.
    }
  }
    
}
